osl::CArray< T, Capacity > Class Template Reference

`#include <container.h>`

Inheritance diagram for osl::CArray< T, Capacity >:

## Public Types

typedef std::remove_cv< T >::type | T_simple
typedef T | value_type
typedef std::array< T, Capacity >::iterator | iterator
typedef std::array< T, Capacity >::const_iterator | const_iterator

## Public Member Functions

T & | operator[] (size_t i)
T const & | operator[] (size_t i) const
T & | operator[] (Player p)
const T & | operator[] (Player p) const
T & | operator[] (PtypeO ptypeo)
const T & | operator[] (PtypeO ptypeo) const
iterator | begin ()
iterator | end ()
void | fill (const T_simple &value=T_simple())
template<class T2, class = typename std::enable_if<!std::is_convertible<T2,T_simple>::value>::type>
void | fill (const T2 &value=T2())
const_iterator | begin () const
const_iterator | end () const
const_iterator | cbegin () const
const_iterator | cend () const
bool | operator== (const CArray &other) const
T & | front ()
T & | back ()
const T & | front () const
const T & | back () const

## Static Public Member Functions

static size_t | size ()

## Public Attributes

std::array< T, Capacity > | array

## Detailed Description

template<typename T, size_t Capacity>
class osl::CArray< T, Capacity >

Definition at line 19 of file container.h.

## Member Typedef Documentation

## const_iterator

template<typename T, size_t Capacity>

typedef std::array<T,Capacity>::const_iterator osl::CArray< T, Capacity >::const_iterator

Definition at line 77 of file container.h.

## iterator

template<typename T, size_t Capacity>

typedef std::array<T,Capacity>::iterator osl::CArray< T, Capacity >::iterator

Definition at line 63 of file container.h.

## T_simple

template<typename T, size_t Capacity>

typedef std::remove_cv<T>::type osl::CArray< T, Capacity >::T_simple

Definition at line 23 of file container.h.

## value_type

template<typename T, size_t Capacity>

typedef T osl::CArray< T, Capacity >::value_type

Definition at line 62 of file container.h.

## Member Function Documentation

## back() [1/2]

template<typename T, size_t Capacity>

T & osl::CArray< T, Capacity >::back | ( |  | ) |

inline

Definition at line 88 of file container.h.

## back() [2/2]

template<typename T, size_t Capacity>

const T & osl::CArray< T, Capacity >::back | ( |  | ) | const

inline

Definition at line 90 of file container.h.

## begin() [1/2]

template<typename T, size_t Capacity>

iterator osl::CArray< T, Capacity >::begin | ( |  | ) |

inline

Definition at line 64 of file container.h.

Referenced by osl::checkmate::Dfpn::defense(), osl::csa::CsaFileMinimal::load(), osl::book::operator<(), osl::book::operator==(), osl::kakinoki::KakinokiFile::parseLine(), osl::record::CsaFile::read(), and osl::eval::PtypeEvalTable::reset().

## begin() [2/2]

template<typename T, size_t Capacity>

const_iterator osl::CArray< T, Capacity >::begin | ( |  | ) | const

inline

Definition at line 78 of file container.h.

## cbegin()

template<typename T, size_t Capacity>

const_iterator osl::CArray< T, Capacity >::cbegin | ( |  | ) | const

inline

Definition at line 80 of file container.h.

## cend()

template<typename T, size_t Capacity>

const_iterator osl::CArray< T, Capacity >::cend | ( |  | ) | const

inline

Definition at line 81 of file container.h.

## end() [1/2]

template<typename T, size_t Capacity>

iterator osl::CArray< T, Capacity >::end | ( |  | ) |

inline

Definition at line 65 of file container.h.

Referenced by osl::csa::CsaFileMinimal::load(), osl::book::operator<(), osl::book::operator==(), osl::kakinoki::KakinokiFile::parseLine(), osl::record::CsaFile::read(), and osl::eval::PtypeEvalTable::reset().

## end() [2/2]

template<typename T, size_t Capacity>

const_iterator osl::CArray< T, Capacity >::end | ( |  | ) | const

inline

Definition at line 79 of file container.h.

## fill() [1/2]

template<typename T, size_t Capacity>
template<class T2, class = typename std::enable_if<!std::is_convertible<T2,T_simple>::value>::type>

void osl::CArray< T, Capacity >::fill | ( | const T2 & | value = T2() | ) |

inline

Definition at line 72 of file container.h.

## fill() [2/2]

template<typename T, size_t Capacity>

void osl::CArray< T, Capacity >::fill | ( | const T_simple & | value = T_simple() | ) |

inline

Definition at line 67 of file container.h.

Referenced by osl::csa::CsaFileMinimal::parseLine(), osl::kakinoki::KakinokiFile::parseLine(), osl::book::BookInMemory::readRecursive(), osl::eval::ml::King25EmptySquareNoEffect::setUpBase(), and osl::move_probability::PatternCommon::updateCacheOne().

## front() [1/2]

template<typename T, size_t Capacity>

T & osl::CArray< T, Capacity >::front | ( |  | ) |

inline

Definition at line 87 of file container.h.

## front() [2/2]

template<typename T, size_t Capacity>

const T & osl::CArray< T, Capacity >::front | ( |  | ) | const

inline

Definition at line 89 of file container.h.

## operator==()

template<typename T, size_t Capacity>

bool osl::CArray< T, Capacity >::operator== | ( | const CArray< T, Capacity > & | other | ) | const

inline

Definition at line 83 of file container.h.

## operator[]() [1/6]

template<typename T, size_t Capacity>

T & osl::CArray< T, Capacity >::operator[] | ( | Player | p | ) |

inline

Definition at line 34 of file container.h.

## operator[]() [2/6]

template<typename T, size_t Capacity>

const T & osl::CArray< T, Capacity >::operator[] | ( | Player | p | ) | const

inline

Definition at line 44 of file container.h.

## operator[]() [3/6]

template<typename T, size_t Capacity>

T & osl::CArray< T, Capacity >::operator[] | ( | PtypeO | ptypeo | ) |

inline

Definition at line 53 of file container.h.

## operator[]() [4/6]

template<typename T, size_t Capacity>

const T & osl::CArray< T, Capacity >::operator[] | ( | PtypeO | ptypeo | ) | const

inline

Definition at line 57 of file container.h.

## operator[]() [5/6]

template<typename T, size_t Capacity>

T & osl::CArray< T, Capacity >::operator[] | ( | size_t | i | ) |

inline

Definition at line 25 of file container.h.

Referenced by osl::CArray< Move, 8 >::operator[](), osl::CArray< Move, 8 >::operator[](), osl::CArray< Move, 8 >::operator[](), and osl::CArray< Move, 8 >::operator[]().

## operator[]() [6/6]

template<typename T, size_t Capacity>

T const & osl::CArray< T, Capacity >::operator[] | ( | size_t | i | ) | const

inline

Definition at line 29 of file container.h.

## size()

template<typename T, size_t Capacity>

size_t osl::CArray< T, Capacity >::size | ( |  | ) |

inline static

Definition at line 76 of file container.h.

Referenced by osl::move_probability::PatternCommon::addOne(), osl::move_probability::BishopAttack::addSquare(), osl::eval::ml::King25Mobility::eval(), osl::eval::ml::SilverAdvance26::eval(), osl::eval::ml::GoldAndSilverNearKing::evalOne(), osl::eval::ml::KnightFork::evalOne(), osl::eval::ml::BishopRookFork::isBishopForkSquare(), osl::eval::ml::BishopRookFork::isRookForkSquare(), osl::move_probability::BreakThreatmate::match(), osl::move_probability::LanceAttack::match(), osl::eval::ml::SilverFork::matchGold(), osl::eval::ml::SilverFork::matchRook(), osl::record::KisenFile::moves(), osl::book::BookInMemory::readRecursive(), and osl::record::Record::setDate().

## Member Data Documentation

## array

template<typename T, size_t Capacity>

std::array<T,Capacity> osl::CArray< T, Capacity >::array

Definition at line 22 of file container.h.

Referenced by osl::CArray< Move, 8 >::operator==().

The documentation for this class was generated from the following file:

- container.h